#ifndef IOCTL_MAN_UD_H
#define IOCTL_MAN_UD_H


#define OFFSET_DMA_DATA_BASE_LO_REG		0x1000
#define OFFSET_DMA_DATA_BASE_HI_REG		0x1004
#define OFFSET_DMA_INDEX_REG			0x1008
#define OFFSET_INTERRUPT_REG			0x100c
#define OFFSET_INTERRUPT_MASK_REG		0x1010
#define OFFSET_MIL_CTRL_REG_PCI			0x2000
#define OFFSET_MIL_RTBM_CONF_REG_PCI		0x2004
#define OFFSET_MIL_BC_CONF_REG_PCI		0x2008
#define OFFSET_MIL_TIME_UTIL_REG_PCI		0x200c
#define OFFSET_MIL_TIME_MATCH_REG_PCI		0x2010
#define OFFSET_MIL_VECW_REG			0x2014
#define OFFSET_MIL_BITW_REG			0x2018
#define OFFSET_MIL_STHW_REG			0x201C
#define OFFSET_MIL_OSTHW_REG			0x2020
#define OFFSET_MIL_MODER_REG			0x2024
#define OFFSET_MIL_MODET_REG			0x2028
#define OFFSET_MIL_RT_INT_REG			0x2034
#define OFFSET_MIL_FREE_TIMER			0x2038
#define OFFSET_MIL_EPROM_CONFIG			0x207c
#define OFFSET_MIL_HW_STAT_REG1			0x2080
#define OFFSET_MIL_HW_STAT_REG2			0x2084
#define OFFSET_MIL_MIL_STAT_REG			0x2088
#define OFFSET_MIL_GPFBC_COND_CORE		0x2090
#define OFFSET_MIL_ADDR_INSTR_BC		0x2094
#define OFFSET_MIL_BC_TIME2NEXT			0x2098
#define OFFSET_MIL_BC_TIME_TAG_COUNTER		0x209c
#define OFFSET_MIL_OPERATION_RAM_POINTER	0x20a0
#define OFFSET_MIL_RT_RCV_REG			0x2100
#define OFFSET_MIL_RT_TR_REG			0x2180
#define OFFSET_MIL_DIS_RCV_REG			0x2200
#define OFFSET_MIL_DIS_TR_REG			0x2280
#define OFFSET_MIL_RT_DATA_BUF0			0x2800
#define OFFSET_MIL_RT_DATA_BUF1			0x3000
#define OFFSET_MIL_BC_DATA_RAM			0x10000
#define OFFSET_MIL_BC_OPERATION_RAM		0x1c000
#define OFFSET_MIL_BC_INSTR_RAM			0x18000


#define DMA_INDEX_REG			1
#define INTERRUPT_REG			2
#define INTERRUPT_MASK_REG		3
#define MIL_CTRL_REG_PCI		4
#define MIL_RTBM_CONF_REG_PCI		5
#define MIL_BC_CONF_REG_PCI		6
#define MIL_TIME_UTIL_REG_PCI		7
#define MIL_TIME_MATCH_REG_PCI		8
#define MIL_VECW_REG			9
#define MIL_BITW_REG			10
#define MIL_STHW_REG			11
#define MIL_OSTHW_REG			12
#define MIL_MODER_REG			13
#define MIL_MODET_REG			14
#define MIL_RT_INT_REG			15
#define MIL_FREE_TIMER			16
#define MIL_EPROM_CONFIG		17
#define MIL_HW_STAT_REG1		18
#define MIL_HW_STAT_REG2		19
#define MIL_MIL_STAT_REG		20
#define MIL_GPFBC_COND_CORE		21 
#define MIL_ADDR_INSTR_BC		22 
#define MIL_BC_TIME2NEXT		23 
#define MIL_BC_TIME_TAG_COUNTER		24 
#define MIL_OPERATION_RAM_POINTER	25 

#define MIL_RT_RCV_REG			26
#define MIL_RT_TR_REG			27
#define MIL_DIS_RCV_REG			28
#define MIL_DIS_TR_REG			29
#define MIL_RT_DATA_BUF0		30
#define MIL_RT_DATA_BUF1		31


#define MIL_BC_DATA_RAM			32
#define MIL_BC_OPERATION_RAM		33
#define MIL_BC_INSTR_RAM		34

#define MAJO 'b'
// read/write regs
#define IOCTL_WR_REG_OFFSET _IOWR(MAJO, 0, SADDR_DATA) //write to reg
#define IOCTL_WR_REG _IOWR(MAJO, 1, SADDR_DATA) //read from reg
#define IOCTL_RD_REG_OFFSET _IOWR(MAJO, 2, SADDR_DATA) //write to reg
#define IOCTL_RD_REG _IOWR(MAJO, 3, SADDR_DATA) //read from reg
// MODE
#define IOCTL_SWITCH_MODE _IOWR(MAJO, 4, MODE_STR) // switch mode between BC, RT, BM, BM + ADDR
// DMA 
#define IOCTL_RESETPOINT _IO(MAJO, 5) // reaset pointer DMA
#define IOCTL_RD_RAW_DMA _IOWR(MAJO, 6, DMA_STR)  // read DMA
#define IOCTL_GET_NBLOCK_RAW_DMA _IOWR(MAJO, 7, unsigned int) // get number of blocks in DMA
#define IOCTL_ENABLE_DMA _IO(MAJO, 8) //enable dma
#define IOCTL_DISABLE_DMA _IO(MAJO, 9) //disable dma
// IRQ
#define IOCTL_DISABLE_INT_HDAT _IO(MAJO, 10) // disable IRQ HDAT
#define IOCTL_DISABLE_INT_QDAT _IO(MAJO, 11) // disable IRQ QDAT
#define IOCTL_DISABLE_INT_FLASH _IO(MAJO, 12) // disable IRQ FLASH
#define IOCTL_DISABLE_INT_BC _IO(MAJO, 13) // disable IRQ BC
#define IOCTL_DISABLE_INT_MC _IO(MAJO, 14) // disable IRQ MC
#define IOCTL_DISABLE_INT_ERR _IO(MAJO, 15) // disable IRQ ERR
#define IOCTL_ENABLE_INT_IO_SA_PID_SIG _IOWR(MAJO, 16, SINTHIOSA) // enable some IRQs 
// channel
#define IOCTL_ENABLE_CHANNEL _IO(MAJO, 17) // enable channel
#define IOCTL_DISABLE_CHANNEL _IO(MAJO, 18) // disable channel
#define IOCTL_SET_ADDRESS _IOWR(MAJO, 19, AD_STR) //set address
#define IOCTL_SET_TIMER_TIMEOUTS _IOWR(MAJO, 20, TT) //set timer and timeout
// paddr and buf
#define IOCTL_ENABLE_PADDR _IOWR(MAJO, 21, SADDR_DATA_PA) //enable paddr
#define IOCTL_DISABLE_PADDR _IOWR(MAJO, 22, SADDR_DATA_PA) //disable paddr
#define IOCTL_WR_REG_PA_RT _IOWR(MAJO, 23, SADDR_DATA_PA) //write to paddr RT
#define IOCTL_RD_REG_PA_RT _IOWR(MAJO, 24, SADDR_DATA_PA) //read from paddr RT
#define IOCTL_WR_REG_PA_DIS _IOWR(MAJO, 25, SADDR_DATA_PA_DIS) //write to paddr DIS
#define IOCTL_RD_REG_PA_DIS _IOWR(MAJO, 26, SADDR_DATA_PA_DIS) //read from paddr DIS
#define IOCTL_WR_BLOCK_BUF_PA _IOWR(MAJO, 27, SBLOCK_BUF_PA) //write block
#define IOCTL_RD_BLOCK_BUF_PA _IOWR(MAJO, 28, SBLOCK_BUF_PA) //read block
//bc_ram_reg
#define IOCTL_WRITE_BC_CONTR_REG _IOWR(MAJO, 29, BC_RAM_STR) // write to BC ram
#define IOCTL_READ_BC_CONTR_REG _IOWR(MAJO, 30, BC_RAM_STR) // read from BC ram
//info command
#define IOCTL_VERSION _IOWR(MAJO, 31, VERSION) // getting information about board
//////////
#define IOCTL_FLASH_TO_DMA_mPCIe_MIL _IOWR(MAJO, 31, void*)


// default signal
#define SIGDEFAULT SIGUSR1

#define RT_MODE		0
#define BC_MODE		1
#define BM_MODE		2
#define BM_ADDR_MODE	3

#define SINTHIOSA_INTR_HDAT	0x00000001
#define SINTHIOSA_INTR_QDAT	0x00000002
#define SINTHIOSA_INTR_FLASH	0x00000004
#define SINTHIOSA_INTR_MC	0x00000008
#define SINTHIOSA_INTR_ERR	0x00000010
#define SINTHIOSA_INTR_SADDR	0x00000020
#define SINTHIOSA_INTR_BC	0x00000040

#define SINTHIOSA_INTR_ALL	0x0000007f

#define DATA		0
#define INSTR		1
#define OPER		2

typedef struct {
	unsigned long daddr;     //u32 0x... or reg_name (MIL_CTRL_REG_PCI)
	unsigned int data;      //u32
	unsigned char buf1[128]; //u8
} SADDR_DATA;

typedef struct {
	unsigned long daddr; //MIL_RT_RCV_REG, MIL_RT_TR_REG
	unsigned int data; // data from/to paddr
	unsigned long paddr; // 1-30 - for RT
} SADDR_DATA_PA;

typedef struct {
	unsigned long daddr; // MIL_DIS_RCV_REG, MIL_DIS_TR_REG
	unsigned long paddrs; // // paddress to be listening from addr (0xffffffff - ALL paddr from addr)
	unsigned long addr; // 0-31 - for BM, BM_ADDR mode (address for listening)
} SADDR_DATA_PA_DIS;

typedef struct {
	unsigned long num_buf;
	unsigned long paddr;
	unsigned short buf[32];
} SBLOCK_BUF_PA;

typedef struct {
	unsigned long type; // DATA, INSTR, OPER
	unsigned long offset;
	unsigned long data;
} BC_RAM_STR;

typedef struct {
	unsigned long proc_pid0;
	unsigned long sig_tosend0;
} SIG_STR;

typedef struct {
	short timeout_rcv; // 00 - 17; 01 - 60; 10 - 85; 11 - 110
	short timeout_tr; // 000 - 6; .....; 111 - 111
	short timer; //1, 2, 4, 8, 16, 32, 64
} TT;

typedef struct {
	unsigned int number_block;
	char buf[100*128];
} DMA_STR;

typedef struct {
	short ad; //address 0..31
} AD_STR;

typedef struct {
	int intr; // INTR_HDAT, INTR_QDAT ...
	int enable_tr;     // 0 - disable
	int enable_rcv; // 0 - disable
	int proc_pid;
	int sig_no;
} SINTHIOSA;

typedef struct {
	short m; // RT_MODE, BC_MODE...
} MODE_STR;

typedef struct {
	unsigned int device_id;
	unsigned int vendor_id;
	char revision;
	char dev_name[30];
	int minor;
	char irq;
	long size_dma;
	void* addr_dma_virt;
	long pci_bars;
} VERSION;

#endif // IOCTL_MAN_UD_H