#include "ioctl_man.h"
#include <fcntl.h>
#include <sys/ioctl.h>

void test_IOCTL_WR_REG_OFFSET(){
	int fd = 0;
	SADDR_DATA add1;
	
	char *filename="/dev/man_ud_dev_0";
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	add1.daddr = 0x1010;
	add1.data = 0x3;
	
	if (ioctl(fd, IOCTL_WR_REG_OFFSET, &add1)){
		printf("Error writing to 0x%x reg.\n", add1.daddr);
	}
	else{
		printf("0x%x was written to 0x%x reg.\n", add1.data, add1.daddr);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_RD_REG_OFFSET(){
	int fd = 0;
	SADDR_DATA add1;
	
	char *filename="/dev/man_ud_dev_0";
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	add1.daddr = 0x1010;
	if (ioctl(fd, IOCTL_RD_REG_OFFSET, &add1)){
		printf("Error reading from 0x%x reg.\n", add1.daddr);
	}
	else{
		printf("0x%x was read from 0x%x reg.\n", add1.data, add1.daddr);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_RD_REG(){
	int fd = 0;
	SADDR_DATA add1;
	
	char *filename="/dev/man_ud_dev_0";
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	add1.daddr = MIL_FREE_TIMER;
	add1.data = 0;

	if (ioctl(fd, IOCTL_RD_REG, &add1)){
		printf("Error reading 0x%x reg.\n", add1.daddr);
	}
	else{
		printf("0x%x was read from 0x%x reg.\n", add1.data, add1.daddr);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_WR_REG(){
	int fd = 0;
	SADDR_DATA add1;
	
	char *filename="/dev/man_ud_dev_0";
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	add1.daddr = MIL_FREE_TIMER;
	add1.data = 0;

	if (ioctl(fd, IOCTL_WR_REG, &add1)){
		printf("Error writing 0x%x reg.\n", add1.daddr);
	}
	else{
		printf("0x%x was written to 0x%x reg.\n", add1.data, add1.daddr);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_SWITCH_MODE(short nMode){
	int fd = 0;

	MODE_STR mode;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_SWITCH_MODE begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	mode.m = nMode;

	if(ioctl(fd,IOCTL_SWITCH_MODE, &mode)){
		printf("Error setting work mode.\n");
	}
	else{
		printf("Work mode was successfully set.\n");
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_RESETPOINT(){
	int fd = 0;
	
	char *filename="/dev/man_ud_dev_0";
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	if(ioctl(fd, IOCTL_RESETPOINT, RT_MODE)){
		printf("Error resetting DMA index.\n");
	}
	else{
		printf("DMA index was successfully reset.\n");
	}

	close(fd);
	printf("Device closed 0 \n");
}


/*void test_IOCTL_RD_RAW_DMA(){
	struct {
		unsigned int number_block;
		unsigned int number_channel;
		char b[128];
	} d;

	int fd = 0;
	
	char *filename="/dev/man_ud_dev_0";
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	d.number_block=10;
	if(ioctl(fd, IOCTL_RD_RAW_DMA, &d)){
		printf("Error reading DMA.\n");
	}
	else{
		printf("Was read %d data blocks from DMA\n", d.number_block);
	}

	close(fd);
	printf("Device closed 0 \n");
}*/

void test_IOCTL_GET_NBLOCK_RAW_DMA(){
	int fd = 0;
	unsigned int nb = 0;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_GET_NBLOCK_RAW_DMA begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	if(ioctl(fd, IOCTL_GET_NBLOCK_RAW_DMA, &nb)){
		printf("Error getting NBLOCK RAW DMA.\n");
	}
	else{
		printf("There is %d of new data block(s).\n", nb);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_ENABLE_DMA(){
	int fd = 0;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_ENABLE_DMA begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	if(ioctl(fd, IOCTL_ENABLE_DMA, 0)){
		printf("IOCTL_ENABLE_DMA error.\n");
	}
	else{
		printf("DMA has been enabled.\n");
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_DISABLE_DMA(){
	int fd = 0;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_DISABLE_DMA begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	if(ioctl(fd, IOCTL_DISABLE_DMA, 0)){
		printf("IOCTL_DISABLE_DMA error.\n");
	}
	else{
		printf("DMA has been disabled.\n");
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_ENABLE_CHANNEL(){
	int fd = 0;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_ENABLE_CHANNEL begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	if(ioctl(fd, IOCTL_ENABLE_CHANNEL, 0)){
		printf("IOCTL_ENABLE_CHANNEL error.\n");
	}
	else{
		printf("Bus A and B are enabled.\n");
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_DISABLE_CHANNEL(){
	int fd = 0;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_DISABLE_CHANNEL begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	if(ioctl(fd, IOCTL_DISABLE_CHANNEL, 0)){
		printf("IOCTL_DISABLE_CHANNEL error.\n");
	}
	else{
		printf("Bus A and B are disabled.\n");
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_SET_ADDRESS(int addr){
	int fd = 0;
	AD_STR sad;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_SET_ADDRESS begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	sad.ad = addr;
	
	if(ioctl(fd, IOCTL_SET_ADDRESS, &sad)){
		printf("IOCTL_SET_ADDRESS error.\n");
	}
	else{
		printf("Address %d was assigned to the device.\n", sad.ad);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_SET_TIMER_TIMEOUTS(){
	int fd = 0;
	TT tit;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_SET_TIMER_TIMEOUTS begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	tit.timer = 4;
	tit.timeout_rcv = 17;
	tit.timeout_tr = 6;
	
	if(ioctl(fd, IOCTL_SET_TIMER_TIMEOUTS, &tit)){
		printf("IOCTL_SET_TIMER_TIMEOUTS error.\n");
	}
	else{
		printf("Values was set:\n timer = %d,\n timeout_tr = %d,\n timeout_rcv = %d.\n", tit.timer, tit.timeout_tr, tit.timeout_rcv);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_ENABLE_PADDR(){
	int fd = 0;
	SADDR_DATA_PA sadpa;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_ENABLE_PADDR begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	sadpa.daddr = MIL_RT_RCV_REG;
	sadpa.paddr = 1;
	
	if(ioctl(fd, IOCTL_ENABLE_PADDR, &sadpa)){
		printf("IOCTL_ENABLE_PADDR error.\n");
	}
	else{
		printf("PAddress number 1 was enable for receive.\n");
	}

	close(fd);
	printf("Device closed 0 \n");
}


void test_IOCTL_DISABLE_PADDR(){
	int fd = 0;
	SADDR_DATA_PA sadpa;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_DISABLE_PADDR begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	sadpa.daddr = MIL_RT_TR_REG;
	sadpa.paddr = 5;
	
	if(ioctl(fd, IOCTL_DISABLE_PADDR, &sadpa)){
		printf("IOCTL_DISABLE_PADDR error.\n");
	}
	else{
		printf("PAddress number 5 was disable for transmit.\n");
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_WR_REG_PA_RT(){
	int fd = 0;
	SADDR_DATA_PA sadpa;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_WR_REG_PA_RT begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	sadpa.daddr = MIL_RT_RCV_REG;
	sadpa.paddr = 3;
	sadpa.data = 0;
	
	if(ioctl(fd, IOCTL_WR_REG_PA_RT, &sadpa)){
		printf("IOCTL_WR_REG_PA_RT error.\n");
	}
	else{
		printf("Value %d was written to PAddress number %d.\n", sadpa.data, sadpa.paddr);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_RD_REG_PA_RT(){
	int fd = 0;
	SADDR_DATA_PA sadpa;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_WR_REG_PA_RT begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	sadpa.daddr = MIL_RT_TR_REG;
	sadpa.paddr = 7;
	
	if(ioctl(fd, IOCTL_WR_REG_PA_RT, &sadpa)){
		printf("IOCTL_WR_REG_PA_RT error.\n");
	}
	else{
		printf("Value 0x%x was read from PAddress number %d.\n", sadpa.data, sadpa.paddr);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_WR_REG_PA_DIS(){
	int fd = 0;
	SADDR_DATA_PA sadpa;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_WR_REG_PA_DIS begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	sadpa.daddr = MIL_DIS_RCV_REG;
	sadpa.paddr = 3;
	sadpa.data = 0;
	
	if(ioctl(fd, IOCTL_WR_REG_PA_DIS, &sadpa)){
		printf("IOCTL_WR_REG_PA_DIS error.\n");
	}
	else{
		printf("Value 0x%x was written to register 0x%x PAddress number %d.\n", sadpa.data, sadpa.daddr, sadpa.paddr);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_RD_REG_PA_DIS(){
	int fd = 0;
	SADDR_DATA_PA sadpa;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_RD_REG_PA_DIS begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	sadpa.daddr = MIL_DIS_RCV_REG;
	sadpa.paddr = 7;
	
	if(ioctl(fd, IOCTL_RD_REG_PA_DIS, &sadpa)){
		printf("IOCTL_RD_REG_PA_DIS error.\n");
	}
	else{
		printf("Value 0x%x was read from register 0x%x PAddress number %d.\n", sadpa.data, sadpa.daddr, sadpa.paddr);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_WR_BLOCK_BUF_PA(){
	int fd = 0;
	SBLOCK_BUF_PA sbbpa;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_WR_BLOCK_BUF_PA begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	sbbpa.num_buf = 0;
	sbbpa.paddr = 3;
	sbbpa.buf[0]=0x5555;
	sbbpa.buf[31]=0xaaaa;
	
	if(ioctl(fd, IOCTL_WR_BLOCK_BUF_PA, &sbbpa)){
		printf("IOCTL_WR_BLOCK_BUF_PA error.\n");
	}
	else{
		printf("sbbpa.buf was written to %d buf, PAddress %d.\n", sbbpa.num_buf, sbbpa.paddr);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_RD_BLOCK_BUF_PA(){
	int fd = 0;
	SBLOCK_BUF_PA sbbpa;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_RD_BLOCK_BUF_PA begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	sbbpa.num_buf = 1;
	sbbpa.paddr = 8;
	
	if(ioctl(fd, IOCTL_RD_BLOCK_BUF_PA, &sbbpa)){
		printf("IOCTL_RD_BLOCK_BUF_PA error.\n");
	}
	else{
		printf("Data has been read from %d buf, PAddress %d to sbbpa.buf.\n", sbbpa.num_buf, sbbpa.paddr);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_WRITE_BC_CONTR_REG(){
	int fd = 0;
	BC_RAM_STR bc;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_WRITE_BC_CONTR_REG begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	bc.type = INSTR;
	bc.offset = 2;
	bc.data = 1;
	
	if(ioctl(fd, IOCTL_WRITE_BC_CONTR_REG, &bc)){
		printf("IOCTL_WRITE_BC_CONTR_REG error.\n");
	}
	else{
		printf("bc.data was written to 3-rd word of instructions.\n");
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_READ_BC_CONTR_REG(){
	int fd = 0;
	BC_RAM_STR bc;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_READ_BC_CONTR_REG begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");

	bc.type = INSTR;
	bc.offset = 2;
	
	if(ioctl(fd, IOCTL_READ_BC_CONTR_REG, &bc)){
		printf("IOCTL_READ_BC_CONTR_REG error.\n");
	}
	else{
		printf("the 3-rd word of instructions = 0x%x.\n", bc.data);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_VERSION(){
	int fd = 0;
	VERSION ver;
	
	char *filename="/dev/man_ud_dev_0";
	printf("IOCTL_VERSION begin.\n");
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");
	
	if(ioctl(fd, IOCTL_VERSION, &ver)){
		printf("IOCTL_VERSION error.\n");
	}
	else{
		printf("revision = 0x%x, \nDMA size = 0x%x. \n", ver.revision, ver.size_dma);
	}

	close(fd);
	printf("Device closed 0 \n");
}

void test_IOCTL_RD_RAW_DMA(){

	int fd = 0, i;
	struct{
	unsigned int number_block;
	unsigned int b[32];
	}d;
	
	char *filename="/dev/man_ud_dev_0";
	fd=open(filename, O_RDWR);
	printf("Device opened 0 \n");
	
	d.number_block=1;

	if (ioctl(fd, IOCTL_RD_RAW_DMA, &d)){
		printf("IOCTL_RD_RAW_DMA error.");
	}
	else{
		if(d.number_block != 0){
			for(i=0; i<32; i++)
				printf("0x%08x\n", d.b[i]);
		}
		else
			printf("IOCTL_RD_RAW_DMA no new data.");
	}

	close(fd);
	printf("Device closed 0 \n");

}


int main(int argc, char *argv[]){
	
	//test_IOCTL_WR_REG_OFFSET();
	//test_IOCTL_RD_REG_OFFSET();
	//test_IOCTL_RD_REG();
	//test_IOCTL_WR_REG();
	//test_IOCTL_SWITCH_MODE();
	//test_IOCTL_RESETPOINT();
	//test_IOCTL_RD_RAW_DMA();
	//test_IOCTL_GET_NBLOCK_RAW_DMA();
	//test_IOCTL_ENABLE_DMA();
	//test_IOCTL_DISABLE_DMA();
	//test_IOCTL_ENABLE_CHANNEL();
	//test_IOCTL_DISABLE_CHANNEL();
	//test_IOCTL_SET_ADDRESS(3);
	//test_IOCTL_SET_TIMER_TIMEOUTS();
	//test_IOCTL_ENABLE_PADDR();
	//test_IOCTL_DISABLE_PADDR();
	//test_IOCTL_WR_REG_PA_RT();
	//test_IOCTL_RD_REG_PA_RT();
	//test_IOCTL_WR_REG_PA_DIS(BM_ADDR_MODE);		//Work mode should be set to BM_ADDR_MODE or BM_MODE
	//test_IOCTL_RD_REG_PA_DIS(BM_ADDR_MODE);		//Work mode should be set to BM_ADDR_MODE or BM_MODE
	//test_IOCTL_WR_BLOCK_BUF_PA(BM_ADDR_MODE);		//Work mode should be set to BM_ADDR_MODE or RT_MODE
	//test_IOCTL_RD_BLOCK_BUF_PA(BM_ADDR_MODE);		//Work mode should be set to BM_ADDR_MODE or RT_MODE
	//test_IOCTL_WRITE_BC_CONTR_REG(BC_MODE);		//Work mode should be set to BC_MODE
	//test_IOCTL_READ_BC_CONTR_REG(BC_MODE);		//Work mode should be set to BC_MODE
	//test_IOCTL_VERSION();
	
	//Module initialization
	/*test_IOCTL_ENABLE_DMA();
	test_IOCTL_SET_ADDRESS(3);
	test_IOCTL_SWITCH_MODE(RT_MODE);
	test_IOCTL_ENABLE_PADDR();
	test_IOCTL_ENABLE_CHANNEL();*/

	//Read new data count
	//test_IOCTL_GET_NBLOCK_RAW_DMA();
	
	//Read data block
	test_IOCTL_RD_RAW_DMA();


	





	

}
