#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <linux/fcntl.h>
#include <linux/unistd.h>
#include <sys/ioctl.h>
#include <signal.h>
#include "ioctl_man.h"

static void sig_handler (int signo)
{
	printf("-----> signal %d\n", signo);
}

int main( int argc, char *argv[] )
{
	int retval;
	int i;
	SADDR_DATA add1;
	unsigned long pid, sig;
	char *nodename = "/dev/man_ud_dev_0";
	SINTHIOSA ss1;


	printf("Test signal \n");
	pid = getpid();
	sig = SIGDEFAULT;
	if (argc > 1) sig = atoi(argv[1]);
	if (argc > 2) pid = atoi(argv[2]);
	if (argc > 3) nodename = argv[3];
	if (SIG_ERR == signal(sig, sig_handler)) printf("set signal handler error \n");

//opening
	i = open(nodename, O_RDWR);
	printf("Device opened 0 \n");


//set signal
	ss1.intr = SINTHIOSA_INTR_QDAT;
	ss1.proc_pid = pid;
	ss1.sig_no = sig;
	retval = ioctl(i, IOCTL_ENABLE_INT_IO_SA_PID_SIG, &ss1);
	if (retval == 0)
	{
		printf("signal set \n");
	}
	else
	{
		printf("error set signal %d \n", retval);
	}



//Read interrupts
	add1.daddr = 0x100C;
	ioctl(i, IOCTL_RD_REG_OFFSET, &add1);
	printf("Device ioctl read stat1 %08x\n", add1.data);


//close
	close(i);
	printf("Device closed 0 \n");

	while (1) pause();
	exit(0);
}
